<script>
  import { onMount } from 'svelte'
  import {
    Cartesian3,
    Color,
    createOsmBuildingsAsync,
    Ion,
    Math as CesiumMath,
    Terrain,
    Viewer,
    buildModuleUrl,
    NearFarScalar,
    HeightReference,
    Cartesian2,
    LabelStyle,
    VerticalOrigin,
    Cartographic,
  } from 'cesium'
  import 'cesium/Build/Cesium/Widgets/widgets.css'
  import { dataset_dev } from 'svelte/internal'

  let cesiumContainer
  export let viewer

  onMount(() => {
    // TODO replace this with a backend API call for token
    Ion.defaultAccessToken = process.env.CESIUM_ION_ACCESS_TOKEN

    buildModuleUrl.setBaseUrl('/Cesium/')
    viewer = new Viewer(cesiumContainer, {
      timeline: false,
      clock: false,
      animation: false,
    })
  })

  let deviceEntities = new Map()
  let satelliteEntities = new Map()

  export function updateDeviceLocation(device) {
    let entity = deviceEntities.get(device.node_id)

    if (entity) {
      entity.position = Cartesian3.fromDegrees(
        device.location.longitude,
        device.location.latitude,
      )
    } else {
      entity = markCoordinate(device)
      deviceEntities.set(device.node_id, entity)
    }
  }

  /**
   * Takes in a device and marks it's location on the map with a pin
   * @param device device to be marked
   */
  function markCoordinate(device) {
    return viewer.entities.add({
      position: Cartesian3.fromDegrees(
        device.location.longitude,
        device.location.latitude,
      ),
      billboard: {
        image: '/assets/pin.svg',
        heightReference: HeightReference.RELATIVE_TO_GROUND,
        disaleDepthTestDistance: 0,
        scale: 0.1,
      },
    })
  }

  export function updateSatelliteLocation(satellite) {
    let entity = satelliteEntities.get(satellite.satellite_id)

    if (entity) {
      entity.position = getSatellitePosition(satellite)
    } else {
      entity = markSatellite(satellite)
      satelliteEntities.set(satellite.satellite_id, entity)
    }
  }

  function getSatellitePosition(satellite) {
    let lat = 90 - satellite.latest_coordinates.elevation // Approximate latitude
    let lon = satellite.latest_coordinates.azimuth - 180 // Approximate longitude
    let height = 2000 * 1000 // Use a predefined altitude

    return Cartesian3.fromDegrees(lon, lat, height)
  }

  function markSatellite(satellite) {
    let satellitePosition = getSatellitePosition(satellite)

    return viewer.entities.add({
      position: satellitePosition,
      billboard: {
        image: '/assets/satellite.png',
        heightReference: HeightReference.RELATIVE_TO_GROUND,
        disaleDepthTestDistance: 0,
        scale: 0.05,
      },
      label: {
        text: 'Satellite ' + satellite.satellite_id,
        font: '10pt monospace',
        style: LabelStyle.FILL_AND_OUTLINE,
        outlineWidth: 2,
        verticalOrigin: VerticalOrigin.BOTTOM,
        pixelOffset: new Cartesian2(0, -20),
      },
    })
  }

  function generateOrbitPathFromSatellite(
    satellitePosition,
    inclinationDegrees,
  ) {
    const orbitPoints = []
    const cartographicPosition = Cartographic.fromCartesian(satellitePosition)
    const satelliteAltitude = cartographicPosition.height // Altitude of the satellite
    const satelliteLongitude = CesiumMath.toDegrees(
      cartographicPosition.longitude,
    ) // Longitude of the satellite

    // Generate points around the globe at the same altitude
    for (let i = 0; i <= 360; i += 5) {
      const lon = (satelliteLongitude + i - 180) % 360 // Adjust longitude to align with satellite
      const lat = inclinationDegrees * Math.sin(CesiumMath.toRadians(i - 180))
      const position = Cartesian3.fromDegrees(lon, lat, satelliteAltitude)
      orbitPoints.push(position)
    }

    return orbitPoints
  }

  // Function to add the orbit path to the viewer
  function addOrbitFromSatellite(satellitePosition) {
    const orbitPath = generateOrbitPathFromSatellite(satellitePosition, 55)
    viewer.entities.add({
      polyline: {
        positions: orbitPath,
        width: 2,
        material: Color.YELLOW,
      },
    })
  }

  /**
   * Wrapper function to fly camera to a location
   * @param latitude
   * @param longitude
   */
  export function centerOnLocation(latitude, longitude) {
    viewer.camera.flyTo({
      destination: Cartesian3.fromDegrees(longitude, latitude, 10000), // Adjust height as needed
    })
  }

  /**
   * Wrapper function to reset camera position
   */
  export function resetCamera() {
    viewer.camera.flyHome()
  }
</script>

<style>
  /* Add custom styles if needed */
</style>

<div
  bind:this={cesiumContainer}
  id="cesiumContainer"
  style="width:100%; height:100vh;" />
